<?php

class ControllerExtensionPaymentAlfa extends Controller
{
    private $error = array();

    /**
     * settings
     */
    public function index()
    {
        $this->library('alfa');
        $alfa = new ALFA();

        $this->load->language('extension/payment/alfa');
        $this->document->setTitle($this->language->get('heading_title'));
        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('payment_alfa', $this->request->post);
            $this->session->data['success'] = $this->language->get('text_success');

            $test_mode = ($this->request->post['payment_alfa_mode'] == 'test') ? true : false;
            if ($alfa->allowCallbacks) {
                $this->_updateGateSettings($test_mode);
            }

            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', 'SSL'));
        }

        // header of page
        $data['heading_title'] = $this->language->get('heading_title');

        // breadcrumbs
        $data['breadcrumbs'] = array();
        array_push($data['breadcrumbs'],
            array(  // main
                'text' => $this->language->get('text_home'),
                'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], 'SSL')
            ),
            array(  // payment
                'text' => $this->language->get('text_payment'),
                'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'], 'SSL')
            ),
            array(  // Payment by
                'text' => $this->language->get('heading_title'),
                'href' => $this->url->link('extension/payment/alfa', 'user_token=' . $this->session->data['user_token'], 'SSL')
            )
        );

        // buttons
        $data['action'] = $this->url->link('extension/payment/alfa', 'user_token=' . $this->session->data['user_token'], 'SSL');
        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'], 'SSL');
        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        // panel heading
        $data['text_settings'] = $this->language->get('text_settings');

        // module state
        $data['entry_status'] = $this->language->get('status');
        $data['status_enabled'] = $this->language->get('status_enabled');
        $data['status_disabled'] = $this->language->get('status_disabled');

        if (isset($this->request->post['payment_alfa_status'])) {
            $data['payment_alfa_status'] = $this->request->post['payment_alfa_status'];
        } else {
            $data['payment_alfa_status'] = $this->config->get('payment_alfa_status');
        }
        // echo   $this->config->get('merchantPassword'); die;
        // $data['payment_alfa_status'] = $data['payment_alfa_status'] = $this->config->get('payment_alfa_status');

        $data['entry_merchantLogin'] = $this->language->get('merchantLogin');
        $data['payment_alfa_merchantLogin'] = $this->config->get('payment_alfa_merchantLogin');
        $data['entry_merchantPassword'] = $this->language->get('merchantPassword');
        $data['payment_alfa_merchantPassword'] = $this->config->get('payment_alfa_merchantPassword');

        $data['entry_mode'] = $this->language->get('mode');
        $data['mode_test'] = $this->language->get('mode_test');
        $data['mode_prod'] = $this->language->get('mode_prod');
        $data['payment_alfa_mode'] = $this->config->get('payment_alfa_mode');

        $data['entry_stage'] = $this->language->get('stage');
        $data['stage_one'] = $this->language->get('stage_one');
        $data['stage_two'] = $this->language->get('stage_two');
        $data['payment_alfa_stage'] = $this->config->get('payment_alfa_stage');

        $data['entry_order_status_completed'] = $this->language->get('entry_order_status_completed');
        if (isset($this->request->post['payment_alfa_order_status_completed_id'])) {
            $data['payment_alfa_order_status_completed_id'] = $this->request->post['payment_alfa_order_status_completed_id'];
        } else {
            $data['payment_alfa_order_status_completed_id'] = $this->config->get('payment_alfa_order_status_completed_id');
        }

        $data['entry_order_status_before'] = $this->language->get('entry_order_status_before');
        if (isset($this->request->post['payment_alfa_order_status_before_id'])) {
            $data['payment_alfa_order_status_before_id'] = $this->request->post['payment_alfa_order_status_before_id'];
        } else {
            $data['payment_alfa_order_status_before_id'] = $this->config->get('payment_alfa_order_status_before_id');
        }

        $this->load->model('localisation/order_status');
        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        $data['entry_sortOrder'] = $this->language->get('entry_sortOrder');
        $data['payment_alfa_sort_order'] = $this->config->get('payment_alfa_sort_order');

        // logging
        $data['entry_logging'] = $this->language->get('logging');
        $data['logging_enabled'] = $this->language->get('logging_enabled');
        $data['logging_disabled'] = $this->language->get('logging_disabled');
        $data['payment_alfa_logging'] = $this->config->get('payment_alfa_logging');

        $data['entry_currency'] = $this->language->get('entry_currency');
        $data['currency_list'] = array_merge(
            array(
                array(
                    'numeric' => 0,
                    'alphabetic' => $this->language->get('entry_currency_default')
                )
            ),
            $this->getCurrencyList()
        );
        $data['payment_alfa_currency'] = $this->config->get('payment_alfa_currency');

        $data['entry_ofdStatus'] = $this->language->get('entry_ofdStatus');
        $data['payment_alfa_ofd_status'] = $this->config->get('payment_alfa_ofd_status');
        $data['entry_ofd_enabled'] = $this->language->get('entry_ofd_enabled');
        $data['entry_ofd_disabled'] = $this->language->get('entry_ofd_disabled');

        $data['entry_taxSystem'] = $this->language->get('entry_taxSystem');
        $data['taxSystem_list'] = $this->getTaxSystemList();
        $data['payment_alfa_taxSystem'] = $this->config->get('payment_alfa_taxSystem');

        $data['entry_taxType'] = $this->language->get('entry_taxType');
        $data['taxType_list'] = $this->getTaxTypeList();
        $data['payment_alfa_taxType'] = $this->config->get('payment_alfa_taxType');


        //FFD version
//        $data['entry_ffdVersionFormat'] = $this->language->get('entry_ffdVersionFormat');
//        $data['FFDVersionList'] = $this->getFFDVersionlist();
//        $data['payment_alfa_ffdVersion'] = $this->config->get('payment_alfa_ffdVersion');

        //FFD method
        $data['entry_paymentMethod'] = $this->language->get('entry_paymentMethod');
        $data['ffd_paymentMethodTypeList'] = $this->getPaymentMethodTypeList();
        $data['payment_alfa_paymentMethodType'] = $this->config->get('payment_alfa_paymentMethodType');

        //FFD delivery method
        $data['entry_paymentMethodDelivery'] = $this->language->get('entry_paymentMethodDelivery');
        $data['payment_alfa_paymentMethodTypeDelivery'] = $this->config->get('payment_alfa_paymentMethodTypeDelivery');

        //FFD object
        $data['entry_paymentObject'] = $this->language->get('entry_paymentObject');
        $data['ffd_paymentObjectTypeList'] = $this->getPaymentObjectTypeList();
        $data['payment_alfa_paymentObjectType'] = $this->config->get('payment_alfa_paymentObjectType');

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $data['alfa_enable_fiscale_options'] = $alfa->alfa_enable_fiscale_options;

        //template rendering
        $this->response->setOutput($this->load->view('extension/payment/alfa', $data));
    }

    /**
     * @return bool
     */
    private function validate()
    {
        if (!$this->user->hasPermission('modify', 'extension/payment/alfa')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }
        return !$this->error;
    }

    public function _updateGateSettings($test_mode = true)
    {
        $this->library('alfa');
        $alfa = new ALFA();

        $this->library('log');
        $file_name = "oc3x_alfapayment_" . date("y-m") . ".log";
        $logger = new Log($file_name);

        $url = new Url(HTTP_CATALOG, $this->config->get('config_secure') ? HTTP_CATALOG : HTTPS_CATALOG);
        $callback_addresses_string = $url->link('extension/payment/alfa/callback');

        $login = $this->config->get('payment_alfa_merchantLogin');
        $password = htmlspecialchars_decode($this->config->get('payment_alfa_merchantPassword'));

        // Endpoints
        if ($test_mode) {
            $action_adr = $alfa->getTestUrl();
            $gate_url = str_replace("payment/rest", "mportal-uat/mvc/public/merchant/update", $action_adr);
            // "mportal-uat" diff for some ONE bank
            //$gate_url = str_replace("rest", "mportal/mvc/public/merchant/update", $action_adr);

        } else {
            $action_adr = $alfa->getProdUrl();
            $gate_url = str_replace("payment/rest", "mportal/mvc/public/merchant/update", $action_adr);
        }

        $gate_url .= substr($login, 0, -4); // we guess username = login w/o "-api"

        $headers = array(
            'Content-Type:application/json',
            'Authorization: Basic ' . base64_encode($login . ":" . $password)
        );

        $data['callbacks_enabled'] = true;
        $data['callback_operations'] = "deposited,approved,declinedByTimeout";
        $data['callback_addresses'] = $callback_addresses_string;

        $ch = curl_init();
        curl_setopt_array($ch, array(
            CURLOPT_HTTPHEADER => $headers,
            CURLOPT_VERBOSE => true,
            CURLOPT_SSL_VERIFYHOST => false,
            CURLOPT_SSL_VERIFYPEER => false,
            CURLOPT_URL => $gate_url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => json_encode($data),
//            CURLOPT_ENCODING, "gzip",
            CURLOPT_ENCODING, '',
        ));
        $response = curl_exec($ch);

        $logger->write("\nREQUEST: " . json_encode($data) . "\nRESPONSE: " . json_encode($response) . "\n");
    }


    /**
     * @return array
     */
    private function getCurrencyList()
    {
        return [
            [
                'numeric' => 643,
                'alphabetic' => 'RUR'
            ],
            [
                'numeric' => 810,
                'alphabetic' => 'RUB'
            ],
            [
                'numeric' => 840,
                'alphabetic' => 'USD'
            ],
            [
                'numeric' => 933,
                'alphabetic' => 'BYN'
            ],
            [
                'numeric' => 978,
                'alphabetic' => 'EUR'
            ],
        ];
    }


    /**

     * @return array
     */
    private function getTaxTypeList()
    {

        return [
            [
                'numeric' => 0,
                'alphabetic' => $this->language->get('entry_no_vat')
            ],
            [
                'numeric' => 1,
                'alphabetic' => $this->language->get('entry_vat0')
            ],
            [
                'numeric' => 2,
                'alphabetic' => $this->language->get('entry_vat10')
            ],
            [
                'numeric' => 3,
                'alphabetic' => $this->language->get('entry_vat18')
            ],
            [
                'numeric' => 4,
                'alphabetic' => $this->language->get('entry_vat10_110')
            ],
            [
                'numeric' => 5,
                'alphabetic' => $this->language->get('entry_vat18_118')
            ],

            [
                'numeric' => 6,
                'alphabetic' => $this->language->get('entry_vat20')
            ],
            [
                'numeric' => 7,
                'alphabetic' => $this->language->get('entry_vat20_120')
            ],
        ];
    }


    /**
     * @return array
     */
    private function getTaxSystemList()
    {
        return [
            [
                'numeric' => 0,
                'alphabetic' => $this->language->get('entry_tax_system_1')
            ],
            [
                'numeric' => 1,
                'alphabetic' => $this->language->get('entry_tax_system_2')
            ],
            [
                'numeric' => 2,
                'alphabetic' => $this->language->get('entry_tax_system_3')
            ],
            [
                'numeric' => 3,
                'alphabetic' => $this->language->get('entry_tax_system_4')
            ],
            [
                'numeric' => 4,
                'alphabetic' => $this->language->get('entry_tax_system_5')
            ],
            [
                'numeric' => 5,
                'alphabetic' => $this->language->get('entry_tax_system_6')
            ],
        ];
    }

    /**
     * @return array
     */
    private function getFFDVersionlist()
    {
        return [
            [
                'value' => 'v10',
                'title' => '1.00'
            ],
            [
                'value' => 'v105',
                'title' => '1.05'
            ],
//            [
//                'value' => 'v11,
//                'title' => '1.1'
//            ],
        ];
    }

    /**
     * @return array
     */
    private function getPaymentMethodTypeList()
    {
        return [
            [
                'numeric' => 1,
                'alphabetic' => $this->language->get('entry_payment_method_1')
            ],
            [
                'numeric' => 2,
                'alphabetic' => $this->language->get('entry_payment_method_2')
            ],
            [
                'numeric' => 3,
                'alphabetic' => $this->language->get('entry_payment_method_3')
            ],
            [
                'numeric' => 4,
                'alphabetic' => $this->language->get('entry_payment_method_4')
            ],
            [
                'numeric' => 5,
                'alphabetic' => $this->language->get('entry_payment_method_5')
            ],
            [
                'numeric' => 6,
                'alphabetic' => $this->language->get('entry_payment_method_6')
            ],
            [
                'numeric' => 7,
                'alphabetic' => $this->language->get('entry_payment_method_7')
            ],

        ];
    }

    /**
     * @return array
     */
    private function getPaymentObjectTypeList()
    {
        return [
            [
                'numeric' => 1,
                'alphabetic' => $this->language->get('entry_payment_object_1')
            ],
            [
                'numeric' => 2,
                'alphabetic' => $this->language->get('entry_payment_object_2')
            ],
            [
                'numeric' => 3,
                'alphabetic' => $this->language->get('entry_payment_object_3')
            ],
            [
                'numeric' => 4,
                'alphabetic' => $this->language->get('entry_payment_object_4')
            ],
            [
                'numeric' => 5,
                'alphabetic' => $this->language->get('entry_payment_object_5')
            ],
//            [
//                'numeric' => 6,
//                'alphabetic' => $this->language->get('entry_payment_object_6')
//            ],
            [
                'numeric' => 7,
                'alphabetic' => $this->language->get('entry_payment_object_7')
            ],
//            [
//                'numeric' => 8,
//                'alphabetic' => $this->language->get('entry_payment_object_8')
//            ],
            [
                'numeric' => 9,
                'alphabetic' => $this->language->get('entry_payment_object_9')
            ],
            [
                'numeric' => 10,
                'alphabetic' => $this->language->get('entry_payment_object_10')
            ],
//            [
//                'numeric' => 11,
//                'alphabetic' => $this->language->get('entry_payment_object_11')
//            ],
            [
                'numeric' => 12,
                'alphabetic' => $this->language->get('entry_payment_object_12')
            ],
            [
                'numeric' => 13,
                'alphabetic' => $this->language->get('entry_payment_object_13')
            ],
        ];
    }

    private function library($library)
    {
        $file = DIR_SYSTEM . 'library/' . str_replace('../', '', (string)$library) . '.php';

        if (file_exists($file)) {
            include_once($file);
        } else {
            trigger_error('Error: Could not load library ' . $file . '!');
            exit();
        }
    }

}